<?php
   /*   
    * Template Name: Blog
   */ 
   get_header();
   get_header('pages');
   
   // Get the post ID
   $post_id = get_the_ID();
   
   // Get the featured image URL
   $featured_image_url = get_the_post_thumbnail_url($post_id);
?>

<div class="banner" style="background-image:url(<?php echo $featured_image_url?>);">
   <div class="container">
      <div class="banner-cnt">
         <h2><?php the_title(); ?></h2>
      </div>
   </div>
</div>

<?php
$args = array(
    'post_type'      => 'post',
    'posts_per_page' => -1, // Number of products to display
    'orderby'        => 'date', // Order products by date
    'order'          => 'DESC', // Show products in descending order
    'post_status'    => 'publish', // Only retrieve published products
);

$loop = new WP_Query( $args );

if ( $loop->have_posts() )
{
?>
<div class="blog-main">
   <div class="container">
      <div class="row">
        <?php
            while ( $loop->have_posts() ) : $loop->the_post();
               $categories = get_the_category();

         ?>
         <div class="col-lg-12">
            <div class="blog">
               <div class="blog-img">
                  <img src="<?php echo get_the_post_thumbnail_url(get_the_ID()); ?>">
               </div>
               <div class="blog-cnt">
                   
                  <?php
                  foreach( $categories as $category ) {
                     echo '<a href="javascript:;" class="learns">'.esc_html( $category->name ).'</a>';
                  }
                  ?>
                  
                  <h3><?php the_title(); ?></h3>
                  <p>By the end of this article, you’ll have the knowledge and skills to play the game of competitive sports picking.</p>
                  <div class="blog-btn">
                     <a href="<?php echo get_permalink(); ?>" class="btn-main">View Post</a>
                  </div>
               </div>
            </div>
         </div>
         <?php
         endwhile;
         ?>
      </div>
   </div>
</div>
<?php 
}
   get_footer(); 
?>