<?php 
require_once(ABSPATH . 'wp-load.php');
require_once(ABSPATH . 'wp-admin/includes/user.php');

add_theme_support( 'title-tag' );

add_theme_support( 'post-thumbnails' );

add_theme_support( 'menus' );

add_theme_support( 'widgets' );

add_theme_support( 'custom-logo' );



add_theme_support( 'html5', array(

	'search-form',

	'comment-form',

	'comment-list',

	'gallery',

	'caption',

) );

// add_filter('wpcf7_form_elements', function($content) {
//     $content = preg_replace('/<(span).*?class="\s*(?:.*\s)?wpcf7-form-control-wrap(?:\s[^"]+)?\s*"[^\>]*>(.*)<\/\1>/i', '\2', $content);

//     return $content;
// });

add_filter('wpcf7_autop_or_not', '__return_false');

add_theme_support( 'post-formats', array(

	'aside',

	'image',

	'video',

	'quote',

	'link',

	'gallery',

	'status',

	'audio',

	'chat',

) );



register_nav_menus( array(

	'primary' => __( 'Primary Menu',      'ramo' ),

	'social'  => __( 'Social Links Menu', 'ramo' ),

) );



load_theme_textdomain( 'ramo' );







/* Google map acf =========================================================================================================== */

add_filter('acf/fields/google_map/api', 'my_acf_google_map_api');

function my_acf_google_map_api( $api )

{

    $api['key'] = 'AIzaSyBfnIktyGzqpFH7z56TBPdeQ7RtMeit4xc';

    return $api;

}

add_action('acf/init', 'my_acf_init');

function my_acf_init() 

{

    acf_update_setting('google_api_key', 'AIzaSyBfnIktyGzqpFH7z56TBPdeQ7RtMeit4xc');

}

/* ========================================================================================================================== */





/* Defer parsing of JavaScript (GtMetrix score up) ========================================================================== */

function defer_parsing_of_js( $url ) {

    if ( is_user_logged_in() ) return $url; //don't break WP Admin

    if ( FALSE === strpos( $url, '.js' ) ) return $url;

    if ( strpos( $url, 'jquery.min.js' ) ) return $url;





    return str_replace( ' src', ' defer src', $url );

}

add_filter( 'script_loader_tag', 'defer_parsing_of_js', 10 );

/* ========================================================================================================================== */





/* Allow Span tags in editor ================================================================================================ */

function myextensionTinyMCE($init) {

    // Command separated string of extended elements

    $ext = 'span[id|name|class|style]';

    // Add to extended_valid_elements if it alreay exists

    if ( isset( $init['extended_valid_elements'] ) ) {

        $init['extended_valid_elements'] .= ',' . $ext;

    } else {

        $init['extended_valid_elements'] = $ext;

    }

    // Super important: return $init!

    return $init;

}

add_filter('tiny_mce_before_init', 'myextensionTinyMCE' );

/* ========================================================================================================================== */





/* Remove text/javascript & text/css attribute ============================================================================== */

add_action( 'template_redirect', function(){

    ob_start( function( $buffer ){

        $buffer = str_replace( array( 'type="text/javascript"', "type='text/javascript'", 'type="text/css"', "type='text/css'" ), '', $buffer );        

        return $buffer;

    });

});

/* ========================================================================================================================== */





/* Emoji script for error solve ============================================================================================= */

function disable_emojicons_tinymce( $plugins ) {

    if ( is_array( $plugins ) ) {

        return array_diff( $plugins, array( 'wpemoji' ) );

    } else {

        return array();

    }

}

function disable_wp_emojicons() {

    // all actions related to emojis

    remove_action( 'admin_print_styles', 'print_emoji_styles' );

    remove_action( 'wp_head', 'print_emoji_detection_script', 7 );

    remove_action( 'admin_print_scripts', 'print_emoji_detection_script' );

    remove_action( 'wp_print_styles', 'print_emoji_styles' );

    remove_filter( 'wp_mail', 'wp_staticize_emoji_for_email' );

    remove_filter( 'the_content_feed', 'wp_staticize_emoji' );

    remove_filter( 'comment_text_rss', 'wp_staticize_emoji' );



    // filter to remove TinyMCE emojis

    add_filter( 'tiny_mce_plugins', 'disable_emojicons_tinymce' );

}

add_action( 'init', 'disable_wp_emojicons' );





/* Display adminbar on frontside ============================================================================================ */

// show admin bar only for admins

/*if (!current_user_can('manage_options')) {

    add_filter('show_admin_bar', '__return_false');

}else{

    add_filter('show_admin_bar', '__return_true');

}*/



// show admin bar only for admins and editors

/*if (!current_user_can('edit_posts')) {

    add_filter('show_admin_bar', '__return_false');

}else{

    add_filter('show_admin_bar', '__return_true');

}*/



/* ========================================================================================================================== */







// /* Custom post type "Video" ============================================================ */

function custom_post_type_video() {

    $labels = array(

        'name'                  => _x( 'videos', 'Post Type General Name', 'ramo' ),

        'singular_name'         => _x( 'video', 'Post Type Singular Name', 'ramo' ),

        'menu_name'             => __( 'Videos', 'ramo' ),

        'name_admin_bar'        => __( 'video', 'ramo' ),

        'archives'              => __( 'video Archives', 'ramo' ),

        'attributes'            => __( 'video Attributes', 'ramo' ),

        'parent_item_colon'     => __( 'Parent video:', 'ramo' ),

        'all_items'             => __( 'All Videos', 'ramo' ),

        'add_new_item'          => __( 'Add New Video', 'ramo' ),

        'add_new'               => __( 'Add New', 'ramo' ),

        'new_item'              => __( 'New video', 'ramo' ),

        'edit_item'             => __( 'Edit video', 'ramo' ),

        'update_item'           => __( 'Update video', 'ramo' ),

        'view_item'             => __( 'View video', 'ramo' ),

        'view_items'            => __( 'View videos', 'ramo' ),

        'search_items'          => __( 'Search video', 'ramo' ),

        'not_found'             => __( 'Not found', 'ramo' ),

        'not_found_in_trash'    => __( 'Not found in Trash', 'ramo' ),

        'featured_image'        => __( 'Featured Image', 'ramo' ),

        'set_featured_image'    => __( 'Set featured image', 'ramo' ),

        'remove_featured_image' => __( 'Remove featured image', 'ramo' ),

        'use_featured_image'    => __( 'Use as featured image', 'ramo' ),

        'insert_into_item'      => __( 'Insert into video', 'ramo' ),

        'uploaded_to_this_item' => __( 'Uploaded to this video', 'ramo' ),

        'items_list'            => __( 'videos list', 'ramo' ),

        'items_list_navigation' => __( 'videos list navigation', 'ramo' ),

        'filter_items_list'     => __( 'Filter videos list', 'ramo' ),

    );

 

    $args = array(

        'labels'             => $labels,

        'public'             => true,

        'publicly_queryable' => true,

        'show_ui'            => true,

        'show_in_menu'       => true,

        'query_var'          => true,

        'rewrite'            => array( 'slug' => 'video' ),

        'capability_type'    => 'post',

        'has_archive'        => true,

        'hierarchical'       => false,

        'menu_position'      => 25,

        'supports'           => array( 'title', 'editor', 'thumbnail', 'revisions', 'custom-fields' ),

        'menu_icon'          => 'dashicons-video-alt3',

    );

 

    register_post_type( 'video', $args );

}

add_action( 'init', 'custom_post_type_video' );



// /* Create taxonomies for project Post ====================================== */

// function project_custom_hierarchical_taxonomies() {

//     $labels = array(

//         'name'              => _x( 'Categories', 'taxonomy general name', 'ramo' ),

//         'singular_name'     => _x( 'Category', 'taxonomy singular name', 'ramo' ),

//         'search_items'      => __( 'Search Categories', 'ramo' ),

//         'all_items'         => __( 'All Categories', 'ramo' ),

//         'parent_item'       => __( 'Parent Category', 'ramo' ),

//         'parent_item_colon' => __( 'Parent Category:', 'ramo' ),

//         'edit_item'         => __( 'Edit Category', 'ramo' ),

//         'update_item'       => __( 'Update Category', 'ramo' ),

//         'add_new_item'      => __( 'Add New Category', 'ramo' ),

//         'new_item_name'     => __( 'New Category Name', 'ramo' ),

//         'menu_name'         => __( 'Categories', 'ramo' ),

//     );



//     $args = array(

//         'hierarchical'      => true,

//         'labels'            => $labels,

//         'show_ui'           => true,

//         'show_admin_column' => true,

//         'query_var'         => true,

//         'rewrite'           => array( 'slug' => 'project_cat' ),

//     );



//     register_taxonomy( 'project_cat', array( 'project' ), $args );

// }

// add_action( 'init', 'project_custom_hierarchical_taxonomies' );







/* Pagination method 1 ===================================================================== */

function pagination_bar( $custom_query ) {



    $total_pages = $custom_query->max_num_pages;

    $big = 999999999; // need an unlikely integer



    if ($total_pages > 1){

        $current_page = max(1, get_query_var('paged'));



        echo paginate_links(array(

            'base' => str_replace( $big, '%#%', 'gg'.esc_url( get_pagenum_link( $big ) ) ),

            'format' => '?paged=%#%',

            'current' => $current_page,

            'total' => $total_pages,

            'prev_text' => '<-',

            'next_text' => '->',

        ));

    }

}



/* Pagination method 2 ===================================================================== */

function wpdocs_get_paginated_links( $query ) {

    // When we're on page 1, 'paged' is 0, but we're counting from 1,

    // so we're using max() to get 1 instead of 0

    $currentPage = max( 1, get_query_var( 'paged', 1 ) );

 

    // This creates an array with all available page numbers, if there

    // is only *one* page, max_num_pages will return 0, so here we also

    // use the max() function to make sure we'll always get 1

    $pages = range( 1, max( 1, $query->max_num_pages ) );

 

    // Now, map over $pages and return the page number, the url to that

    // page and a boolean indicating whether that number is the current page

    return array_map( function( $page ) use ( $currentPage ) {

        return ( object ) array(

            "isCurrent" => $page == $currentPage,

            "page" => $page,

            "url" => get_pagenum_link( $page )

        );

    }, $pages );

}


/* Custom post type "Testimonial" ============================================================ */
function custom_post_type_testimonial() {
    $labels = array(
        'name'                  => _x( 'Testimonials', 'Post Type General Name', 'ramo' ),
        'singular_name'         => _x( 'Testimonial', 'Post Type Singular Name', 'ramo' ),
        'menu_name'             => __( 'Testimonials', 'ramo' ),
        'name_admin_bar'        => __( 'Testimonial', 'ramo' ),
        'archives'              => __( 'Testimonial Archives', 'ramo' ),
        'attributes'            => __( 'Testimonial Attributes', 'ramo' ),
        'parent_item_colon'     => __( 'Parent Testimonial:', 'ramo' ),
        'all_items'             => __( 'All Testimonials', 'ramo' ),
        'add_new_item'          => __( 'Add New Testimonial', 'ramo' ),
        'add_new'               => __( 'Add New', 'ramo' ),
        'new_item'              => __( 'New Testimonial', 'ramo' ),
        'edit_item'             => __( 'Edit Testimonial', 'ramo' ),
        'update_item'           => __( 'Update Testimonial', 'ramo' ),
        'view_item'             => __( 'View Testimonial', 'ramo' ),
        'view_items'            => __( 'View Testimonials', 'ramo' ),
        'search_items'          => __( 'Search Testimonial', 'ramo' ),
        'not_found'             => __( 'Not found', 'ramo' ),
        'not_found_in_trash'    => __( 'Not found in Trash', 'ramo' ),
        'featured_image'        => __( 'Featured Image', 'ramo' ),
        'set_featured_image'    => __( 'Set featured image', 'ramo' ),
        'remove_featured_image' => __( 'Remove featured image', 'ramo' ),
        'use_featured_image'    => __( 'Use as featured image', 'ramo' ),
        'insert_into_item'      => __( 'Insert into testimonial', 'ramo' ),
        'uploaded_to_this_item' => __( 'Uploaded to this testimonial', 'ramo' ),
        'items_list'            => __( 'Testimonials list', 'ramo' ),
        'items_list_navigation' => __( 'Testimonials list navigation', 'ramo' ),
        'filter_items_list'     => __( 'Filter testimonials list', 'ramo' ),
    );
 
    $args = array(
        'labels'             => $labels,
        'public'             => true,
        'publicly_queryable' => true,
        'show_ui'            => true,
        'show_in_menu'       => true,
        'query_var'          => true,
        'rewrite'            => array( 'slug' => 'testimonial' ),
        'capability_type'    => 'post',
        'has_archive'        => true,
        'hierarchical'       => false,
        'menu_position'      => 25,
        'supports'           => array( 'title', 'editor', 'thumbnail', 'revisions', 'custom-fields' ),
        'menu_icon'          => 'dashicons-testimonial',
    );
 
    register_post_type( 'testimonial', $args );
}
add_action( 'init', 'custom_post_type_testimonial' );

/* Create taxonomies for testimonial Post ====================================== */
function testimonial_custom_hierarchical_taxonomies() {
    $labels = array(
        'name'              => _x( 'Categories', 'taxonomy general name', 'ramo' ),
        'singular_name'     => _x( 'Category', 'taxonomy singular name', 'ramo' ),
        'search_items'      => __( 'Search Categories', 'ramo' ),
        'all_items'         => __( 'All Categories', 'ramo' ),
        'parent_item'       => __( 'Parent Category', 'ramo' ),
        'parent_item_colon' => __( 'Parent Category:', 'ramo' ),
        'edit_item'         => __( 'Edit Category', 'ramo' ),
        'update_item'       => __( 'Update Category', 'ramo' ),
        'add_new_item'      => __( 'Add New Category', 'ramo' ),
        'new_item_name'     => __( 'New Category Name', 'ramo' ),
        'menu_name'         => __( 'Categories', 'ramo' ),
    );

    $args = array(
        'hierarchical'      => true,
        'labels'            => $labels,
        'show_ui'           => true,
        'show_admin_column' => true,
        'query_var'         => true,
        'rewrite'           => array( 'slug' => 'testimonial_cat' ),
    );

    register_taxonomy( 'testimonial_cat', array( 'testimonial' ), $args );
}
add_action( 'init', 'testimonial_custom_hierarchical_taxonomies' );


function cf7_secure_gravatar( $url ) {
    if ( strpos( $url, 'http://www.gravatar.com' ) === 0 ) {
        $url = set_url_scheme( $url, 'https' );
    }
    return $url;
}
add_filter( 'get_avatar_url', 'cf7_secure_gravatar' );

function custom_post_type_press() {
    $labels = array(
        'name'                  => _x( 'Press', 'Post Type General Name', 'ramo' ),
        'singular_name'         => _x( 'Press', 'Post Type Singular Name', 'ramo' ),
        'menu_name'             => __( 'Press', 'ramo' ),
        'name_admin_bar'        => __( 'Press', 'ramo' ),
        'archives'              => __( 'Press Archives', 'ramo' ),
        'attributes'            => __( 'Press Attributes', 'ramo' ),
        'parent_item_colon'     => __( 'Parent Press:', 'ramo' ),
        'all_items'             => __( 'All Press', 'ramo' ),
        'add_new_item'          => __( 'Add New Press', 'ramo' ),
        'add_new'               => __( 'Add New', 'ramo' ),
        'new_item'              => __( 'New Press', 'ramo' ),
        'edit_item'             => __( 'Edit Press', 'ramo' ),
        'update_item'           => __( 'Update Press', 'ramo' ),
        'view_item'             => __( 'View Press', 'ramo' ),
        'view_items'            => __( 'View Press', 'ramo' ),
        'search_items'          => __( 'Search Press', 'ramo' ),
        'not_found'             => __( 'Not found', 'ramo' ),
        'not_found_in_trash'    => __( 'Not found in Trash', 'ramo' ),
        'featured_image'        => __( 'Featured Image', 'ramo' ),
        'set_featured_image'    => __( 'Set featured image', 'ramo' ),
        'remove_featured_image' => __( 'Remove featured image', 'ramo' ),
        'use_featured_image'    => __( 'Use as featured image', 'ramo' ),
        'insert_into_item'      => __( 'Insert into Press', 'ramo' ),
        'uploaded_to_this_item' => __( 'Uploaded to this Press', 'ramo' ),
        'items_list'            => __( 'Press list', 'ramo' ),
        'items_list_navigation' => __( 'Press list navigation', 'ramo' ),
        'filter_items_list'     => __( 'Filter Press list', 'ramo' ),
    );
 
    $args = array(
        'labels'             => $labels,
        'public'             => true,
        'publicly_queryable' => true,
        'show_ui'            => true,
        'show_in_menu'       => true,
        'query_var'          => true,
        'rewrite'            => array( 'slug' => 'press' ),
        'capability_type'    => 'post',
        'has_archive'        => true,
        'hierarchical'       => false,
        'menu_position'      => 25,
        'supports'           => array( 'title', 'editor', 'thumbnail', 'revisions', 'custom-fields' ),
        'menu_icon'          => 'dashicons-format-aside',
    );
 
    register_post_type( 'press', $args );
}
add_action( 'init', 'custom_post_type_press' );